import pandas as pd
import nltk
from nltk import word_tokenize, FreqDist
from nltk.corpus import stopwords
from nltk.stem import WordNetLemmatizer
from nltk.tokenize import TweetTokenizer
import re
from nltk.sentiment import SentimentIntensityAnalyzer
#installing tweet-preprocessor
#!pip install tweet-preprocessor

import preprocessor as p
from wordcloud import WordCloud
import matplotlib.pyplot as plt
plt.style.use('fivethirtyeight')

# https://towardsdatascience.com/basic-tweet-preprocessing-in-python-efd8360d529e
# load in the dataframe
df = pd.read_csv('C:/Users/meera/Desktop/BTCSample.csv', index_col="user_followers_count")
btcP1 = pd.read_csv('C:/Users/meera/Desktop/BTCPart1Eng.csv')
btcP2 = pd.read_csv('C:/Users/meera/Desktop/BTCPart2Eng.csv')

# Retrieving columns by indexing operator
followers = df[["user_name", "user_description", "user_status_count"]]
print(followers)


#p.clean()


#  Text-Cleaning (URLs, Mentions, etc.)
for i,v in enumerate(df['text']):
    df.loc[i,'text'] = p.clean(v)


text= df['text']



# Tokenization , Removal of Digits, Stop Words and Punctuations
nltk.download
nltk.download('wordnet')
nltk.download('stopwords')

# Remove Digits and lower the text (makes it easy to deal with)
data = text.astype(str).str.replace('\d+', '')
lower_text = data.str.lower()


# Remove Punctuations

def remove_punctuation(words):
 new_words = []
 for word in words:
    new_word = re.sub(r'[^\w\s]', '', (word))
    if new_word != '':
       new_words.append(new_word)
 return new_words

new_text  = remove_punctuation(lower_text)




#Frequency of words

from ekphrasis.classes.segmenter import Segmenter
# segmenter using the word statistics from Twitter
seg_tw = Segmenter(corpus="twitter")
a = []
df2 = pd.DataFrame(new_text, columns = ['Segmented#'])
for i in range(len(new_text)):
 if new_text[i] != a:
     listToStr1 = ''.join([str(elem) for elem in new_text[i]])
     df2.loc[i,'Segmented#'] = seg_tw.segment(listToStr1)


segtext = df2['Segmented#']
#fdist = FreqDist(new_text)
# fdist = FreqDist(tweets['Segmented#'])
fdist = FreqDist()
sent = 'This is an example sentence this is this this'
#for word in word_tokenize(str(new_text)):
for word in word_tokenize(str(segtext)):
    fdist[word.lower()] += 1

fdist.keys()
fdist.values()

#list(fdist.keys())


#WordCloud
wc = WordCloud(width=800, height=400, max_words=50).generate_from_frequencies(fdist)
plt.figure(figsize=(12,10))
plt.imshow(wc, interpolation="bilinear")
plt.axis("off")
plt.show()

# Sentiment analysis

sia = SentimentIntensityAnalyzer()
sia.polarity_scores("Wow, NLTK is really powerful!")

# sia.polarity_scores(text[1])

